addhook("second", "nz_playerSecond")
addhook("join", "nz_join")
addhook("team", "nz_team")
addhook("spawn", "nz_spawn")
addhook("serveraction", "nz_serverAction")
addhook("attack2", "nz_attack2")
addhook("move", "nz_move")
addhook("movetile", "nz_moveTile")
addhook("hit", "nz_hit")
addhook("kill", "nz_kill")
addhook("die", "nz_die")
addhook("use", "nz_use")

function nz_updatePosition(id)
	id = tonumber(id)
	
	nz_lastX[id] = player(id, "x")
	nz_lastY[id] = player(id, "y")
end

function nz_updatePositionTile(id)
	id = tonumber(id)
	
	nz_lastTileX[id] = player(id, "tilex")
	nz_lastTileY[id] = player(id, "tiley")
end

function nz_updateMoney(id)
	nz_money[id] = player(id, "money")
end

function nz_restoreSpeed(id)
	id = tonumber(id)
	
	parse("speedmod "..id.." "..nz_speedMod[id])
end


function nz_playerSecond()
	-- display a status of the current wave
	local minute = math.floor(nz_waveTime / 60)
	local second = nz_waveTime - (minute * 60)

	if (second < 10) then
		second = "0"..second
	end

	for _, v in ipairs(player(0, "table")) do
		if nz_wave < 30 then
		parse("hudtxt 0 \"032255032Time Remaining: "..minute..": "..second.."\" 98 120 1")
		parse("hudtxt 1 \"032255032Wave: "..nz_wave.." of 30 ".."\" 74 135 1")
		else
			parse("hudtxt 0 \"032255032Time remaining: KILL BOSS".."\" 114 120 1")
			parse("hudtxt 1 \"032255032Last wave!".."\" 64 135 1")
			parse("hudtxt 2 \"032255032Credits: Bownok (Script)".."\" 102 150 1")
			parse("hudtxt 3 \"124252000Credits: Left 4 n00b (Map + Mod)".."\" 130 165 1")
			parse("hudtxt 4 \"032255032Credits: Textual Context (Help in lua)".."\" 139 180 1")
		end
	end
	
	for _, v in ipairs(player(0, "team1living")) do
		-- meth
		if (nz_class[v] == "meth") then
			-- chance for special
			if (math.random(1, 100) <= 10) then
				local targetList = player(0, "team2living")
				if math.random(1, 2)==1 then	-- choosing the special		
					if (#targetList > 0) then
					local target = math.random(1, #targetList)

					parse("setpos "..v.." "..player(targetList[target], "x").." "..player(targetList[target], "y"))
					parse('effect "colorsmoke" ' .. player(targetList[target], 'x') .. ' ' .. player(targetList[target], 'y') .. ' 0 64 255 255 255')
				
					function nz_methTeleportBack(id)
						id = tonumber(id)
						local targetList = player(0, "team1living")
						local target = math.random(1, #targetList)
						
						parse('effect "colorsmoke" ' .. player(v, 'x') .. ' ' .. player(v, 'y') .. ' 0 64 255 255 255')
						parse("setpos "..v.." "..player(targetList[target], "x").." "..player(targetList[target], "y"))
					end
					
					timer(1000, "nz_methTeleportBack", id)

					end
					elseif math.random(1,2)==2 then -- this can also fail
					if (#targetList > 0) then
						local target = math.random(1, #targetList)
						parse("weapon m3; drop; weapon mp5; drop; weapon p90; drop; weapon mac10; drop; weapon ump45; drop; weapon xm1014; drop; weapon m4a1; drop; weapon ak47; drop; weapon aug; drop; weapon sg552; drop; weapon m249; drop")
						parse('effect "colorsmoke" ' .. player(targetList[target], 'x') .. ' ' .. player(targetList[target], 'y') .. ' 0 64 32 255 32')
					end
				end
			end
		-- darth valdamere
		elseif (nz_class[v] == "darthvaldamere") then
			nz_dv_rageMeter[v] = 0
		-- gutter
		elseif (nz_class[v] == "gutter") then
			parse("equip "..v.." 86")

		elseif (nz_class[v] == "titan") then
			if math.random(1,50) >= 45 then
				local targetList = player(0, "team2living")
				if (#targetList > 0) then
				local target = math.random(1, #targetList)
					parse("explosion "..player(targetList[target], "x").." "..player(targetList[target], "y").." 16 5 "..v)
				end
			end
		elseif (nz_class[v] == "dread") then
			if math.random (1,4) == 1 then
				nz_slow(v, 5, 2500)
			end
		elseif (nz_class[v] == "dc") then
			-- chance for special
			if (math.random(1, 100) <= 2.5) then
				local targetList = player(0, "team2living")
					if (#targetList > 0) then
					local id = math.random(1, #targetList)
					parse("customkill "..v.." Banned "..id)
					msg("Another ban for the DC! @C")
					end
			end
		end
	end
end

function nz_join(id)
	nz_money[id] = 0
end

function nz_team(id, team, look)
	if (not player(id, "bot") and team == 1) then
		msg2(id, "You will respawn if your squad survive this wave.")
		
		parse("makespec "..id)
		
		return 1
	end
end

function nz_spawn(id)
	-- restore the player speedmod
	nz_speedMod[id] = 0
	
	-- free the zombie sprite
	if (nz_image[id] ~= nil) then
		freeimage(nz_image[id])
		nz_image[id] = nil
	end
	
	-- fix the zombie name
	if (player(id, "bot") and player(id, "name"):sub(1, #"zombie"):lower() ~= "zombie") then
		parse("setname "..id.." Zombie")
	end
	
	-- zombie spawn
	if (player(id, "team") == 1) then	
		local playerCount = 0
		
		-- update the player and bot count
		for _, v in ipairs(player(0, "table")) do
			if (not player(v, "bot")) then
				playerCount = playerCount + 1
			end
		end
		
		-- modify the health of the zombie if its past wave 5
		local waveModifier = (nz_wave - 5) * 5
		
		if (waveModifier < 0) then
			waveModifier = 0
		end
		
		-- normal zombie
		nz_class[id] = "zombie"
		nz_maxHealth[id] = 500 + (waveModifier * 10)
		nz_speedMod[id] = -15
		nz_bounty[id] = 5
		
		-- wave 2
		if (nz_wave >= 2) and (nz_wave < 30) then
			-- sprinter
			if (nz_class[id] == "zombie" and math.random(1, 100) <= 25) then
				nz_class[id] = "sprinter"
				nz_maxHealth[id] = 250 + (waveModifier*5)
				nz_speedMod[id] = 5
				nz_bounty[id] = 10
				
				nz_image[id] = image(nz_IMAGES.."zombie/sprinter.png", 1, 0, 200 + id)
			end
		end
		
		-- wave 3
		if (nz_wave >= 5) and (nz_wave < 30) then
			-- toxic zombie
			if (nz_class[id] == "zombie" and math.random(1, 100) <= 20) then
				nz_class[id] = "toxic zombie"
				nz_maxHealth[id] = 500 + (waveModifier*15)
				nz_speedMod[id] = -8
				nz_bounty[id] = 15
				
				nz_image[id] = image(nz_IMAGES.."zombie/toxic zombie.png", 1, 0, 200 + id)
			end
			-- wraith
		end

		if (nz_wave  >= 7)  and (nz_wave < 30) then
			-- gutter
			if (nz_class[id] == "zombie" and math.random(1, 100) <= 75) then
				nz_class[id] = "stealth"
				nz_maxHealth[id] = 300 + (waveModifier*10)
				nz_speedMod[id] = -2.5
				nz_bounty[id] = 35
				parse("equip "..id.." 84")			end
		end
		if (nz_wave >= 9) and (nz_wave < 30) then
			if (nz_class[id] == "zombie" and math.random(1, 100) <= 15) then
				nz_class[id] = "wraith"
				nz_maxHealth[id] = 400 + (playerCount * 10) + (waveModifier*15)
				nz_speedMod[id] = -10
				nz_bounty[id] = 20
				
				nz_image[id] = image(nz_IMAGES.."zombie/wraith.png", 1, 0, 200 + id)
			end
		end
		
		-- wave 4
		if (nz_wave  >= 14)  and (nz_wave < 30) then
			-- gutter
			if (nz_class[id] == "zombie" and math.random(1, 100) <= 20) then
				nz_class[id] = "gutter"
				nz_maxHealth[id] = waveModifier*15
				nz_speedMod[id] = -6
				nz_bounty[id] = 25
				
				nz_image[id] = image(nz_IMAGES.."zombie/gutter.png", 1, 0, 200 + id)
			end
		end
		
		if (nz_wave == 10) then
			if (nz_class[id] == "zombie" and not nz_dread) then
				msg("Danger: Dread has spawned! @C")
				nz_dread = true
				nz_class[id] = "dread"
				nz_maxHealth[id] = 2000 + (playerCount * 2000)
				nz_speedMod[id] = -2
				nz_bounty[id] = 500
				nz_image[id] = image(nz_IMAGES.."zombie/meth.png", 1, 0, 200 + id)
				parse("setname "..id.." Dread")
			end
		end

		if (nz_wave == 20) then
			if (nz_class[id] == "zombie" and not nz_titan) then
				msg("Danger: Titan has spawned! @C")

				nz_titan = true
				nz_class[id] = "titan"
				nz_maxHealth[id] = 4000 + (playerCount * 3000)
				nz_speedMod[id] = -6.75
				nz_bounty[id] = 750
				nz_image[id] = image(nz_IMAGES.."zombie/titan.png", 1, 0, 200 + id)
				parse("setname "..id.." Titan")
			end
		end
		
		if (nz_wave == 30)  then
			-- meth
			if (nz_class[id] == "zombie" and not nz_meth) then
				msg("Danger: Chaos has spawned! @C")
				
				nz_meth = true
				nz_class[id] = "meth"
				nz_maxHealth[id] = 6000 + (playerCount * 4000)
				nz_speedMod[id] = -3
				nz_bounty[id] = 15000
				nz_image[id] = image(nz_IMAGES.."zombie/bownok.png", 1, 0, 200 + id)
				
				parse("setname "..id.." Chaos")
				nz_lastWave = true
			end
		end

		if nz_wave == 1 and nz_methkill == true then
			-- meth
			if (nz_class[id] == "zombie" and not nz_dc) then
				msg("WTF?!?!?! DC has spawned! @C")
				
				nz_dc = true
				nz_class[id] = "dc"
				nz_maxHealth[id] = 10000 + (playerCount * 7500)
				nz_bounty[id] = 0
				parse("setpos "..id.." 576 544")
				nz_image[id] = image(nz_IMAGES.."zombie/dc.png", 1, 0, 200 + id)
				parse("setname "..id.." DC")
				nz_methkill = false
				parse("spawnitem 45 14 15")
				parse("spawnitem 45 16 15")
				parse("spawnitem 45 14 18")
				parse("spawnitem 45 16 18")
				nz_speedMod[id] = -25
				parse("speedmod "..id.." -100")
			end
		end
		-- set the zombie health
		nz_health[id] = nz_maxHealth[id]
		else
		-- if the survivor is a bot, don't set them money
		if (not player(id, "bot")) then
			parse("setmoney "..id.." "..nz_money[id])
			local random = math.random(1, 3)
				if random == 1 then
					parse("equip "..id.." "..math.random(10,11))
				elseif random == 2 then
					parse("equip "..id.." "..math.random(20,24))
				elseif random == 3 then
					parse("equip "..id.." "..math.random(1, 5))
				end
		end
	
	-- update the player position
	nz_updatePosition(id)
	nz_updatePositionTile(id)
	
	-- restore the player speed
	nz_restoreSpeed(id)
end
end


function nz_updateHealth(id)
	local percent = math.floor((nz_health[id] / nz_maxHealth[id]) * 100)
	
	if (percent < 1) then
		percent = 1
	end
	
	parse("sethealth "..id.." "..percent)
end

function nz_slow(id, amount, slowTime)
	parse("speedmod "..id.." "..amount)
	
	timer(slowTime, "nz_restoreSpeed", id)
end


function nz_hit(id, source, weapon, healthDamage, armorDamage)
	if (player(id, "team") == 1 and player(source, "team") == 2) then
		local damage = itemtype(weapon, "dmg")
		
		if (nz_health[id] > damage) then
			nz_health[id] = nz_health[id] - damage
			
			nz_updateHealth(id)
			
			return 1
		end
	end
	
	if (weapon == 255) then
		parse("setpos "..id.." "..(nz_lastTileX[id]*32+16).." "..(nz_lastTileY[id]*32+16))
		nz_slow(id, -100, 750)
		return 1
	end
end

function nz_serverAction(id, action)
	-- close the mini-tutorial
	if (action == 3) then
		if (nz_tutorial[id]) then
			nz_tutorial[id] = false
			
			for i = 0, 4 do
				hudtxt2(id, i, "", 0, 0, 0)
			end
		end
	end
end

function nz_attack2(id, mode)
	-- display an error if the player attempt to scope in with a weapon
	local scopeWeapon = {SG552, AUG, SCOUT, AWP, G3SG1, SG550}
	
	if (mode == 1) then
		local weapon = player(id, "weapontype")
		
		for _, v in ipairs(scopeWeapon) do
			if (v == weapon) then
				msg2(id,"Scoping in with weapons does not increase your damage!")
			end
		end
	end
end

function nz_move(id, x, y)
	-- update the zombie position
	if (player(id, "team") == 2) then
		timer(1, "nz_updatePosition", id)
	end
end

function nz_moveTile(id, x, y, walk)
	if (player(id, "team") == 2) then
		if (entity(x, y, "exists")) then
			if (entity(x, y, "trigger") == "barbedwire") then
				parse("setpos "..id.." "..nz_lastX[id].." "..nz_lastY[id])
			end
		end
	end
	-- wait a mili-second before updating the player position
	timer(1, "nz_updatePositionTile", id)
end

function nz_kill(id, victim, weapon, x, y)
	-- update the player money
	if (player(id, "team") == 2) then
		parse("setmoney "..id.." "..nz_bounty[victim]+player(id, "money")- 300)
		nz_updateMoney(id)
		parse("sethealth "..id.." "..player(id, "health")+5)
		if nz_bounty[victim] == 15000 then
			parse("trigger demoend")
			nz_methkill = true
		elseif nz_bounty[victim] == 0 then
			for _, all in ipairs(player(0, "team1living")) do
				parse("setmoney "..id.." "..player(all, "money")+3000)
			end
		end
	end
end

function nz_die(id, source, weapon, x, y)
	-- free the zombie sprite
	nz_health[id] = 0
	if (nz_image[id] ~= nil) then
		freeimage(nz_image[id])
		nz_image[id] = nil
	end
	
	-- display the death message of boss zombie
	
	-- toxic zombie create a smoke effect
	if (player(id, "team") == 1) then
		if (nz_class[id] == "toxic zombie") then
			parse("effect colorsmoke"..x.." "..y.." 100 32 0 255 0")
		end
	end
	
	-- bot drop nothing when they die as a survivor
	if (player(id, "bot")) then
		return 1
	end
end

function nz_use(id, event, data, x, y)
	if (player(id, "team") == 2) then
		if (event == 100) then
			-- repairing barbed wire
			if (entity(x, y, "trigger") == "barbedwire") then
				for _, v in ipairs(object(0, "table")) do
					if (object(v, "tilex") == x and object(v, "tiley") == y) then
					parse("killobject "..v)
					end
				end				
			parse("spawnobject 2 "..x.." "..y)
			-- buying weapon
			elseif (entity(x, y, "trigger") == "ammo") then
				if (player(id, "money") >= 30) then
					parse("setmoney "..id.." "..player(id, "money")- 30)
					nz_updateMoney(id)			
					parse("equip "..id.." 61")
					msg2(id, "032255032You bought primary ammo for 50$")
				else
					msg2(id, "255032032You dont have enough money!")
				end
			elseif (entity(x, y, "trigger") == "ammo1") then
				if (player(id, "money") >= 15) then
					parse("setmoney "..id.." "..player(id, "money")- 15)
					nz_updateMoney(id)			
					parse("equip "..id.." 62")
					msg2(id, "032255032You bought secondary ammo for 25$")
				else
					msg2(id, "255032032You dont have enough money!")
				end
			end
		end
	end
end
